///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//-----------------------------------------------------------------------------------------------------------------------------------------
//  Yahtzee version 0.4 by GuZzO             24-09-2010
//-----------------------------------------------------------------------------------------------------------------------------------------
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Program Yahtzee;

global

//GP2X Keys
__A = _control;
__B = _alt;
__X = _x;
__Y = _y;
__SELECT = _space;
__R = _tab;
__L = _backspace;
__START = _enter;
__VolP = _a;
__VolM = _s;

//Sprites & Fonts & Music
fpg1;
fnt1;
fnt2;
fnt3;
fnt4;

snd1; //Intro menu
snd2; //Bruit de ds
text_tour;
text_player;
text_screen;

//Compteur
num_de;
cptr;
cptr_tirage;
active_player;
nombre_joueur;
tour;
cptr_tour;
cptr_tour_total;

//Verifie qu'aucne n'est enfonce
keypressed;
test_roll_button;
test_stop_button;
test_choix_dices;

//Choix de l'attribution du resultat
resultat_valide;
resultat_tmp1;
resultat_tmp2;

//Chargement des ds
Struct roll_dice[4];
	value;
	roll;
	ref_process;
End;

//Enregistrement des resultats
Struct resultats[4] [17];
	value;
	done;
End;

//Nombre d'occurence d'un d
Struct dice_occurence[6];
	number;
End;


BEGIN

		//Initialisation de l'cran
		set_mode(320,240,16);
		set_fps(30,0);
		
		//Chargement des grfx
		fpg1 = load_fpg("gfx_yahtzee.fpg");
		fnt1 = load_fnt("font_titre.fnt");
		fnt2 = load_fnt("font_medium_002.fnt");
		fnt3 = load_fnt("font_medium_001.fnt");
		fnt4 = load_fnt("font_small_001.fnt");
		set_text_color(rgb(0,0,0));

		// Chargement du splash-screen
		put_screen(fpg1,998); 
		frame;
		
		patiente(100);
		
		fade(0,0,0,1);
		while (fading)
			frame;
		end
		// Fin du splash-screen		


		//Fire up the menu
		Menu();
      
END



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MENU - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PROCESS Menu()

private
i;
text;

BEGIN

		let_me_alone();
		
		///////////////////////////CHARGEMENTS PARAMETRES
		snd1 = load_wav ("sound_01.wav");
		play_wav (snd1,-1);
		nombre_joueur = 2;

		PUT_SCREEN ( fpg1,13); //Affiche l'arrire plan
		graph = write_in_map(1,"- YAHTZEE -",4);
		x = 160;
		y = 40;

		Write(fnt2, 160,100,1,"Press Start or");
		Write(fnt2, 160,120,1,"touch screen !");
		Write(fnt2, 160,145,1,"...Select to quit");
		Write(fnt4, 15,217,0,"by GuZzO - 2010");
		
		text = write(fnt2,160,190,4,"Player : " + nombre_joueur);
		
		///////////////////////////FIN - CHARGEMENTS PARAMETRES
		
		Loop
			//Exit If pressed escape
			If (key(__SELECT))	exit();	End
		


			///////////////////////////TITRE TOURNANT
			//Vitesse de rotation
			i+=6000;
			
			//Taille du texte qui tourne
			size_x = 150;
			size_y = abs(get_distx(i,150));
			//Rotation du texte
			If (get_distx(i,200)<0)
				flags = 2;
			Else
				flags = 0;
			End
			///////////////////////////FIN - TITRE TOURNANT


			
			///////////////////////////CHOIX NB JOUEUR
			//Switch nombre_joueur AND fix variables according to that
			If (key(_left) AND nombre_joueur>2)
				nombre_joueur--; //Dscrmente la variable nombre_joueur de -1
				delete_text(text);
				text = write(fnt2,160,190,4,"Player : " + nombre_joueur);
				While(key(_left))	Frame;	End
			End
			
			//Switch nombre_joueur AND fix variables according to that
			If (key(_right) AND nombre_joueur<4)
				nombre_joueur++; //Incrmente la variable nombre_joueur de +1
				delete_text(text);
				text = write(fnt2,160,190,4,"Player : " + nombre_joueur);
				While(key(_right))	Frame;	End
			End
			///////////////////////////FIN - CHOIX NB JOUEUR
			
			
			//break out of the Loop If the game is started
			If (key(__START) or mouse.left)	break;	End
			
			//AND exit If select is pressed
			If (key(__SELECT))	exit("",0);	End
			
			Frame;
		End
		
		//START GAME
		//============
		Fade_off();
		
		//AND fire up the game logic
		UNload_wav (snd1);
		Game();

END



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Corps du Jeu -  finir
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PROCESS Game()

Private
Resultats_tmp;
end_game;

BEGIN


		let_me_alone();
		
		//Chargement de la souris
		Curseur();
		Fade_on();
		
		//Initialisation des paramtres joueurs
		active_player = 1;
		cptr_tirage = 1;
		cptr_tour = 1;
		cptr_tour_total = 0;
		end_game = 0;
		
		roll_dice[0].roll = true;
		roll_dice[1].roll = true;
		roll_dice[2].roll = true;
		roll_dice[3].roll = true;
		roll_dice[4].roll = true;
		

		While (mouse.left) Frame; End;
		
		Loop

			If (end_game == 0)  // Vrifie  quel moment du jeu on est (13 tours pour finir le jeu)
				cptr_tour_total = cptr_tour_total + 1;
							
				If (key(__START))
					Pause();
					//Repeat	Frame;	Until (!key(__START));		
					Loop	
						Frame;	
						If (key(__L) AND key(__R)) 
							Game_over();	
						Elsif (key(__SELECT))
							signal(type Pause,s_kill);
							Frame;
							Break;
						End;
					End;		
				End;
				
				If (cptr_tirage > 3)// RInitialise les paramtres aprs 3 tirages de ds
					If (active_player > nombre_joueur)	
						active_player = 1;
						cptr_tour = cptr_tour + 1;	
					End; //Retour au joueur 1 quAND tout le monde a jou
					roll_dice[0].roll = true;
					roll_dice[1].roll = true;
					roll_dice[2].roll = true;
					roll_dice[3].roll = true;
					roll_dice[4].roll = true;
					cptr_tirage = 1;
				End;
	
	

				Nettoyage_ecran (); //Clean the screen
				signal(type Display_roll_button,s_kill);//Supprime ROLL
				Display_stop_button();//Affiche STOP
				
				write(fnt2, 100, 140, 1, ("Round " + (cptr_tour) + "-" + (cptr_tirage)) );
				write(fnt2, 100, 160, 1, "Player " + active_player);

				Loop				
						From num_de = 0  to 4 step 1
								if (num_de == 0)
									signal(type Rolling_Dice,s_kill);
								end;
								Rolling_Dice(num_de); //Tire 5 ds alatoirement
						End;
						Frame(200);
											
						If (mouse.left AND test_stop_button !=0)	break;	End; //Action : temporise et oblige  relver le stylet pour continuer
				End;
					
				snd2 = load_wav ("sound_02.wav");
				play_wav (snd2,1);
				Patiente(rand(5,20));
				play_wav (snd2,1);
				Patiente(rand(5,20));
				play_wav (snd2,1);
                                UNload_wav (snd2);
				
				signal(type Display_stop_button,s_kill);//Supprime STOP
				signal(type Rolling_Dice,s_kill);
				
				If (cptr_tirage == 3)
					Display_roll_button(1);//Affiche SCORES
				Else
					Display_roll_button(0);//Affiche ROLL
				End;


				Loop
						//While (mouse.left)	Frame;	End;
						From num_de = 0  to 4 step 1
							Display_dices(num_de);
						End;
						Frame(250);
						If (mouse.left AND test_roll_button !=0)	break;	End; //Action : temporise et oblige  relver le stylet pour continuer
				End;
				


				If (roll_dice[0].roll == false AND roll_dice[1].roll == false AND roll_dice[2].roll == false AND roll_dice[3].roll == false AND roll_dice[4].roll == false)
					If (cptr_tirage == 1)
						cptr_tirage = 3;
						cptr_tour_total = cptr_tour_total + 2;
					Elsif (cptr_tirage == 2)
						cptr_tirage = 3;
						cptr_tour_total = cptr_tour_total + 1;						
					Else
						cptr_tirage = 3;
					End;
				End				

				
				
				
				//////////////////////////////////////////////////////////////////////
				//resultatS
				//////////////////////////////////////////////////////////////////////
				If (cptr_tirage == 3)
				
					resultat_valide = -1;
					resultat_tmp2 = 0; //OK
					Fade_off();
					signal(type Display_dices,s_kill);
					signal(type Display_roll_button,s_kill);//Supprime ROLL
				
					Repeat
						If (mouse.left==0 AND mouse.left==0 AND key(_up)==0 AND key(_down)==0 AND key(_left)==0 AND key(_right)==0 AND key(_alt)==0 AND key(_z)==0 AND key(_x)==0 AND key(_enter)==0 AND key(_control)==0 AND key(_tab)==0 AND key(_backspace)==0)	keypressed=0;	End
						delete_text(all_text);
						Table_resultats ();
						Display_resultats ();
						//write(fnt2, 100, 160, 1, "test 1 " + cptr_tour_total);
						Frame(200);
					Until(keypressed==0 AND !(resultat_valide == -1) AND ((mouse.left AND mouse.x>=(286) AND mouse.x<=(315) AND mouse.y>=(208) AND mouse.y<=(232))))
				
					While (mouse.left) 
						Frame;
						signal(type Display_resultats_animation ,s_kill);
					End;

					resultats [active_player] [resultat_valide].value = resultat_tmp2;
					resultats [active_player] [resultat_valide].done = 1;
					resultat_valide = -1;
					
					cptr_tirage += 1;				
					active_player = active_player + 1;
					
					
					
					If (cptr_tour_total >= (13 * 3 * nombre_joueur))
						//write(fnt1, 100, 180, 1, "test 2");
						End_game = 1;
					End;
									
					Frame(200);
				
					If (key(__SELECT)) Go_back_menu();End
					
					Fade_off();
				Else
					cptr_tirage += 1;				
				End;
				
				///////////////////////////////////////////////////////////////////////
				//FIN DE resultatS
				//////////////////////////////////////////////////////////////////////
			
			Else  // cptr_tour_total est suprieur (X * nombre_joueur)			
				Game_over();
				Frame(200);			
			End; //EndIf (cptr_tour_total =< (3 * (nombre_joueur+1)))
		
		End; //End Loop
		
END



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Anime les chiffres du resultats provisoire - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PROCESS Display_resultats_animation (x,y,z,graph);

BEGIN

		loop
			repeat
				size++;
				frame(50);
			until (size==110);
			repeat
				size--;
				frame(50);
			until (size==80);
		end;
		
END



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Tirage des ds - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PROCESS Rolling_Dice(int id_dice)

BEGIN
	
	
		If (roll_dice[id_dice].roll == true)
				roll_dice[id_dice].value = rand(1,6);
				graph = roll_dice[id_dice].value;
				x = (40 * (id_dice + 1));
				y = 200;
		Elsif (roll_dice[id_dice].roll == false)
				graph = (roll_dice[id_dice].value + 6);
				x = (40 * (id_dice + 1));
				y = 200;
		End;
		
		Loop
				frame;//and draw it! (damn fenix is complicated)
		End;
		
END


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Affichage des ds - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PROCESS Display_dices (INT id_dice)
//Display the result

Private;
y_min = 185;
y_max = 215;

BEGIN

		If (mouse.left AND mouse.x>=((40*(id_dice+1))-15) AND mouse.x<=((40*(id_dice+1))+15) AND mouse.y>=y_min AND mouse.y<=y_max)
				If (roll_dice[id_dice].roll == true) //Conserve les ds slectionns en noir
						roll_dice[id_dice].roll = false;
				Elseif
						roll_dice[id_dice].roll = true;
				End;
		End;
		
		If (roll_dice[id_dice].roll == true) //Conserve les ds slectionns en noir
				put(fpg1, (roll_dice[id_dice].value), (40*(id_dice+1)), 200);
		Elseif
				put(fpg1, roll_dice[id_dice].value + 6, (40*(id_dice+1)), 200);
		End;

		//Frame;
			    
END



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Vrification des resultats - PAS OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PROCESS Table_resultats ()
//Calcul les resultats

Private
cptr_resultat1;
cpt_player;


BEGIN
      resultat_tmp1 = -1;
      
            //les 1 OK ////////////////////////////////
            If (mouse.left AND mouse.x>=(0) AND mouse.x<=(28) AND mouse.y>=(24) AND mouse.y<=(47));
              If (resultats [active_player] [0].done == 0)
              resultat_tmp1 = 0;
                From cptr_resultat1 = 0 to 4 step 1
                     If (roll_dice[cptr_resultat1].value == 1)
                        resultat_tmp1 = resultat_tmp1 + 1;
                     End;
                resultat_valide = 0;
                End;
              End;
            End;
      
      
            //les 2 OK ////////////////////////////////
            If (mouse.left AND mouse.x>=(0) AND mouse.x<=(28) AND mouse.y>=(48) AND mouse.y<=(71));
              If (resultats [active_player] [1].done == 0)
              resultat_tmp1 = 0;
                From cptr_resultat1 = 0 to 4 step 1
                   If (roll_dice[cptr_resultat1].value == 2)
                      resultat_tmp1 = resultat_tmp1 + 2;
                   End;
              resultat_valide = 1;
              End;
              End;
            End;
      
      
            //les 3 OK ////////////////////////////////
            If (mouse.left AND mouse.x>=(0) AND mouse.x<=(28) AND mouse.y>=(72) AND mouse.y<=(95));
              If (resultats [active_player] [2].done == 0)
            resultat_tmp1 = 0;
              From cptr_resultat1 = 0 to 4 step 1
                   If (roll_dice[cptr_resultat1].value == 3)
                      resultat_tmp1 = resultat_tmp1 + 3;
                   End;
              resultat_valide = 2;
              End;
              End;
            End;
      
      
            //les 4 OK ////////////////////////////////
            If (mouse.left AND mouse.x>=(0) AND mouse.x<=(28) AND mouse.y>=(96) AND mouse.y<=(119));
              If (resultats [active_player] [3].done == 0)
            resultat_tmp1 = 0;
              From cptr_resultat1 = 0 to 4 step 1
                   If (roll_dice[cptr_resultat1].value == 4)
                      resultat_tmp1 = resultat_tmp1 + 4;
                   End;
              resultat_valide = 3;
              End;
              End;
            End;
      
      
            //les 5 OK ////////////////////////////////
            If (mouse.left AND mouse.x>=(0) AND mouse.x<=(28) AND mouse.y>=(120) AND mouse.y<=(143));
              If (resultats [active_player] [4].done == 0)
            resultat_tmp1 = 0;
              From cptr_resultat1 = 0 to 4 step 1
                   If (roll_dice[cptr_resultat1].value == 5)
                      resultat_tmp1 = resultat_tmp1 + 5;
                   End;
              resultat_valide = 4;
              End;
              End;
            End;
      
      
            //les 6 OK ////////////////////////////////
            If (mouse.left AND mouse.x>=(0) AND mouse.x<=(28) AND mouse.y>=(144) AND mouse.y<=(168));
              If (resultats [active_player] [5].done == 0)
            resultat_tmp1 = 0;
              From cptr_resultat1 = 0 to 4 step 1
                   If (roll_dice[cptr_resultat1].value == 6)
                      resultat_tmp1 = resultat_tmp1 + 6;
                   End;
              resultat_valide = 5;
              End;
              End;
            End;
         
      
            //SOUS TOTAL OK ////////////////////////////////
              resultats[1] [6].value = (resultats[1] [0].value + resultats[1] [1].value + resultats[1] [2].value + resultats[1] [3].value + resultats[1] [4].value + resultats[1] [5].value);
              resultats[2] [6].value = (resultats[2] [0].value + resultats[2] [1].value + resultats[2] [2].value + resultats[2] [3].value + resultats[2] [4].value + resultats[2] [5].value);
              resultats[3] [6].value = (resultats[3] [0].value + resultats[3] [1].value + resultats[3] [2].value + resultats[3] [3].value + resultats[3] [4].value + resultats[3] [5].value);
              resultats[4] [6].value = (resultats[4] [0].value + resultats[4] [1].value + resultats[4] [2].value + resultats[4] [3].value + resultats[4] [4].value + resultats[4] [5].value);
      
      
            //TOTAL1 OK ////////////////////////////////
              If (resultats[1] [6].value > 62)
                 resultats[1] [7].value = (resultats[1] [6].value + 25);
              Else
                 resultats[1] [7].value = resultats[1] [6].value;
              End;
      
              If (resultats[2] [6].value > 62)
                 resultats[2] [7].value = (resultats[2] [6].value + 25);
              Else
                 resultats[2] [7].value = resultats[2] [6].value;
              End;
      
              If (resultats[3] [6].value > 62)
                 resultats[3] [7].value = (resultats[3] [6].value + 25);
              Else
                 resultats[3] [7].value = resultats[3] [6].value;
              End;
      
              If (resultats[4] [6].value > 62)
                 resultats[4] [7].value = (resultats[4] [6].value + 25);
              Else
                 resultats[4] [7].value = resultats[4] [6].value;
              End;
      
      
         
         
            //le minimum OK ////////////////////////////////
            If (mouse.left AND mouse.x>=(140) AND mouse.x<=(168) AND mouse.y>=(0) AND mouse.y<=(23));
              If (resultats [active_player] [8].done == 0)
              resultat_tmp1 = (roll_dice[0].value + roll_dice[1].value + roll_dice[2].value + roll_dice[3].value + roll_dice[4].value);
              resultat_valide = 8;
            End;
            End;
      
            //le maximum OK ////////////////////////////////
            If (mouse.left AND mouse.x>=(140) AND mouse.x<=(168) AND mouse.y>=(24) AND mouse.y<=(47));
              If (resultats [active_player] [9].done == 0)
              resultat_tmp1 = (roll_dice[0].value + roll_dice[1].value + roll_dice[2].value + roll_dice[3].value + roll_dice[4].value);
              resultat_valide = 9;
            End;
            End;
      
            //TOTAL2 OK ////////////////////////////////
              resultats[1] [10].value = (resultats[1] [9].value - resultats[1] [8].value);
              resultats[2] [10].value = (resultats[2] [9].value - resultats[2] [8].value);
              resultats[3] [10].value = (resultats[3] [9].value - resultats[3] [8].value);
              resultats[4] [10].value = (resultats[4] [9].value - resultats[4] [8].value);
      
         
         
            //Brelan OK ////////////////////////////////
            If (mouse.left AND mouse.x>=(140) AND mouse.x<=(168) AND mouse.y>=(72) AND mouse.y<=(95));
              If (resultats [active_player] [11].done == 0)
                  Occurence_tirage();
                  If ((dice_occurence [1].number >= 3) OR (dice_occurence [2].number >= 3) OR (dice_occurence [3].number >= 3) OR (dice_occurence [4].number >= 3) OR (dice_occurence [5].number >= 3) OR (dice_occurence [6].number >= 3))
                    resultat_tmp1 = (10 + roll_dice[0].value + roll_dice[1].value + roll_dice[2].value + roll_dice[3].value + roll_dice[4].value);
                    resultat_valide = 11;
                  Else
                    resultat_tmp1 = 0;
                    resultat_valide = 11;
                  End;
              End;
            End;
      
            //Suites OK ////////////////////////////////
            If (mouse.left AND mouse.x>=(140) AND mouse.x<=(168) AND mouse.y>=(96) AND mouse.y<=(119));
              If (resultats [active_player] [12].done == 0)
                 Occurence_tirage();
                 If (((dice_occurence [1].number == 1) AND (dice_occurence [2].number == 1) AND (dice_occurence [3].number == 1) AND (dice_occurence [4].number == 1) AND (dice_occurence [5].number == 1)) OR (((dice_occurence [2].number == 1) AND (dice_occurence [3].number == 1) AND (dice_occurence [4].number == 1) AND (dice_occurence [5].number == 1) AND (dice_occurence [6].number == 1))))
                   resultat_tmp1 = (20 + roll_dice[0].value + roll_dice[1].value + roll_dice[2].value + roll_dice[3].value + roll_dice[4].value);
                   resultat_valide = 12;
                 Else
                   resultat_tmp1 = 0;
                   resultat_valide = 12;
                 End;
              End;
            End;
            
            //Full
            If (mouse.left AND mouse.x>=(140) AND mouse.x<=(168) AND mouse.y>=(120) AND mouse.y<=(143));
              If (resultats [active_player] [13].done == 0)
                  Occurence_tirage();
                  If ((dice_occurence [1].number == 3) OR (dice_occurence [2].number == 3) OR (dice_occurence [3].number == 3) OR (dice_occurence [4].number == 3) OR (dice_occurence [5].number == 3) OR (dice_occurence [6].number == 3))
                        
                        If ((dice_occurence [1].number == 2) OR (dice_occurence [2].number == 2) OR (dice_occurence [3].number == 2) OR (dice_occurence [4].number == 2) OR (dice_occurence [5].number == 2) OR (dice_occurence [6].number == 2))
                          resultat_tmp1 = (30 + roll_dice[0].value + roll_dice[1].value + roll_dice[2].value + roll_dice[3].value + roll_dice[4].value);
                          resultat_valide = 13;
                        Else
                          resultat_tmp1 = 0;
                          resultat_valide = 13;
                        End;
      
                  Else
                    resultat_tmp1 = 0;
                    resultat_valide = 13;
                  End;
      
            End;
            End;
      
            //Carr  OK ////////////////////////////////
            If (mouse.left AND mouse.x>=(140) AND mouse.x<=(168) AND mouse.y>=(144) AND mouse.y<=(168));
              If (resultats [active_player] [14].done == 0)
                  Occurence_tirage();
                  If ((dice_occurence [1].number >= 4) OR (dice_occurence [2].number >= 4) OR (dice_occurence [3].number >= 4) OR (dice_occurence [4].number >= 4) OR (dice_occurence [5].number >= 4) OR (dice_occurence [6].number >= 4))
                    resultat_tmp1 = (40 + roll_dice[0].value + roll_dice[1].value + roll_dice[2].value + roll_dice[3].value + roll_dice[4].value);
                    resultat_valide = 14;
                  Else
                    resultat_tmp1 = 0;
                    resultat_valide = 14;
                  End;
      
            End;
            End;
      
      
      
            //yam's OK ////////////////////////////////
            If (mouse.left AND mouse.x>=(140) AND mouse.x<=(168) AND mouse.y>=(169) AND mouse.y<=(192));
              If (resultats [active_player] [15].done == 0)
      
                    If ((roll_dice[0].value == roll_dice[1].value) AND (roll_dice[1].value == roll_dice[2].value) AND (roll_dice[2].value == roll_dice[3].value) AND (roll_dice[3].value == roll_dice[4].value))
                              resultat_tmp1 = (50 + roll_dice[0].value + roll_dice[1].value + roll_dice[2].value + roll_dice[3].value + roll_dice[4].value);
                              resultat_valide = 15;
                    Else
                              resultat_tmp1 = 0;
                              resultat_valide = 15;
                    End;
              End;
             End;
      
      
      
			//TOTAL3 OK ////////////////////////////////
			resultats[1] [16].value = (resultats[1] [11].value + resultats[1] [12].value + resultats[1] [13].value + resultats[1] [14].value + resultats[1] [15].value);
			resultats[2] [16].value = (resultats[2] [11].value + resultats[2] [12].value + resultats[2] [13].value + resultats[2] [14].value + resultats[2] [15].value);
			resultats[3] [16].value = (resultats[3] [11].value + resultats[3] [12].value + resultats[3] [13].value + resultats[3] [14].value + resultats[3] [15].value);
			resultats[4] [16].value = (resultats[4] [11].value + resultats[4] [12].value + resultats[4] [13].value + resultats[4] [14].value + resultats[4] [15].value);
			
			
			//TOTAL FINAL OK ////////////////////////////////
			resultats[1] [17].value = (resultats[1] [7].value + resultats[1] [10].value + resultats[1] [16].value);
			resultats[2] [17].value = (resultats[2] [7].value + resultats[2] [10].value + resultats[2] [16].value);
			resultats[3] [17].value = (resultats[3] [7].value + resultats[3] [10].value + resultats[3] [16].value);
			resultats[4] [17].value = (resultats[4] [7].value + resultats[4] [10].value + resultats[4] [16].value);
			
		If (resultat_tmp1 <> -1)
			signal(type Display_resultats_animation ,s_kill);
			//unload_map(0, graph);
			resultat_tmp2 = resultat_tmp1;
			Display_resultats_animation (15,12,0,write_in_map(fnt3,resultat_tmp2,4));
		End;
      
END



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Affiche le tableau des resultats - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PROCESS Display_resultats ()

BEGIN
		
		Fade_on();
		
		If (active_player == 1) PUT_SCREEN ( fpg1,17); End; //Affiche en arrire plan le tableau des resultats du joueur 1
		If (active_player == 2) PUT_SCREEN ( fpg1,18); End; //Affiche en arrire plan le tableau des resultats du joueur 2
		If (active_player == 3) PUT_SCREEN ( fpg1,19); End; //Affiche en arrire plan le tableau des resultats du joueur 3
		If (active_player == 4) PUT_SCREEN ( fpg1,20); End; //Affiche en arrire plan le tableau des resultats du joueur 4
		
		put(fpg1, roll_dice[0].value, 300, 25); //Affiche le 1er d dans le bandeau de droite
		put(fpg1, roll_dice[1].value, 300, 65); //Affiche le 2me d dans le bandeau de droite
		put(fpg1, roll_dice[2].value, 300, 105); //Affiche le 3me d dans le bandeau de droite
		put(fpg1, roll_dice[3].value, 300, 145); //Affiche le 4me d dans le bandeau de droite
		put(fpg1, roll_dice[4].value, 300, 185); //Affiche le 5me d dans le bandeau de droite
		
		
		//AFFICHAGE DES resultatS////////////////////////////////
		//1/////////////////////////// 
		If (resultats [1] [0].done == 1); write ( 0, (14+(28*1)), 35, 1, resultats[1] [0].value); End;
		If (resultats [2] [0].done == 1); write ( 0, (14+(28*2)), 35, 1, resultats[2] [0].value); End;
		If (resultats [3] [0].done == 1); write ( 0, (14+(28*3)), 35, 1, resultats[3] [0].value); End;
		If (resultats [4] [0].done == 1); write ( 0, (14+(28*4)), 35, 1, resultats[4] [0].value); End;
		
		//2///////////////////////////
		If (resultats [1] [1].done == 1); write ( 0, (14+(28*1)), 60, 1, resultats[1] [1].value); End;
		If (resultats [2] [1].done == 1); write ( 0, (14+(28*2)), 60, 1, resultats[2] [1].value); End;
		If (resultats [3] [1].done == 1); write ( 0, (14+(28*3)), 60, 1, resultats[3] [1].value); End;
		If (resultats [4] [1].done == 1); write ( 0, (14+(28*4)), 60, 1, resultats[4] [1].value); End;
		
		//3///////////////////////////
		If (resultats [1] [2].done == 1); write ( 0, (14+(28*1)), 82, 1, resultats[1] [2].value); End;
		If (resultats [2] [2].done == 1); write ( 0, (14+(28*2)), 82, 1, resultats[2] [2].value); End;
		If (resultats [3] [2].done == 1); write ( 0, (14+(28*3)), 82, 1, resultats[3] [2].value); End;
		If (resultats [4] [2].done == 1); write ( 0, (14+(28*4)), 82, 1, resultats[4] [2].value); End;
		
		//4///////////////////////////
		If (resultats [1] [3].done == 1); write ( 0, (14+(28*1)), 106, 1, resultats[1] [3].value); End;
		If (resultats [2] [3].done == 1); write ( 0, (14+(28*2)), 106, 1, resultats[2] [3].value); End;
		If (resultats [3] [3].done == 1); write ( 0, (14+(28*3)), 106, 1, resultats[3] [3].value); End;
		If (resultats [4] [3].done == 1); write ( 0, (14+(28*4)), 106, 1, resultats[4] [3].value); End;
		
		//5////////////////////////////
		If (resultats [1] [4].done == 1); write ( 0, (14+(28*1)), 128, 1, resultats[1] [4].value); End;
		If (resultats [2] [4].done == 1); write ( 0, (14+(28*2)), 128, 1, resultats[2] [4].value); End;
		If (resultats [3] [4].done == 1); write ( 0, (14+(28*3)), 128, 1, resultats[3] [4].value); End;
		If (resultats [4] [4].done == 1); write ( 0, (14+(28*4)), 128, 1, resultats[4] [4].value); End;
		
		//6////////////////////////////
		If (resultats [1] [5].done == 1); write ( 0, (14+(28*1)), 152, 1, resultats[1] [5].value); End;
		If (resultats [2] [5].done == 1); write ( 0, (14+(28*2)), 152, 1, resultats[2] [5].value); End;
		If (resultats [3] [5].done == 1); write ( 0, (14+(28*3)), 152, 1, resultats[3] [5].value); End;
		If (resultats [4] [5].done == 1); write ( 0, (14+(28*4)), 152, 1, resultats[4] [5].value); End;
		
		//SOUS-TOTAL///////////////////
		write ( 0, (14+(28*1)), 178, 1, resultats[1] [6].value);
		write ( 0, (14+(28*2)), 178, 1, resultats[2] [6].value);
		write ( 0, (14+(28*3)), 178, 1, resultats[3] [6].value);
		write ( 0, (14+(28*4)), 178, 1, resultats[4] [6].value);
		
		//T1///////////////////////////
		write ( 0, (14+(28*1)), 200, 1, resultats[1] [7].value);
		write ( 0, (14+(28*2)), 200, 1, resultats[2] [7].value);
		write ( 0, (14+(28*3)), 200, 1, resultats[3] [7].value);
		write ( 0, (14+(28*4)), 200, 1, resultats[4] [7].value);
		
		//MIN//////////////////////////
		If (resultats [1] [8].done == 1); write ( 0, (154+(28*1)), 10, 1, resultats[1] [8].value); End;
		If (resultats [2] [8].done == 1); write ( 0, (154+(28*2)), 10, 1, resultats[2] [8].value); End;
		If (resultats [3] [8].done == 1); write ( 0, (154+(28*3)), 10, 1, resultats[3] [8].value); End;
		If (resultats [4] [8].done == 1); write ( 0, (154+(28*4)), 10, 1, resultats[4] [8].value); End;
		
		//MAX//////////////////////////
		If (resultats [1] [9].done == 1); write ( 0, (154+(28*1)), 35, 1, resultats[1] [9].value); End;
		If (resultats [2] [9].done == 1); write ( 0, (154+(28*2)), 35, 1, resultats[2] [9].value); End;
		If (resultats [3] [9].done == 1); write ( 0, (154+(28*3)), 35, 1, resultats[3] [9].value); End;
		If (resultats [4] [9].done == 1); write ( 0, (154+(28*4)), 35, 1, resultats[4] [9].value); End;
		
		//T2///////////////////////////
		write ( 0, (154+(28*1)), 60, 1, resultats[1] [10].value);
		write ( 0, (154+(28*2)), 60, 1, resultats[2] [10].value);
		write ( 0, (154+(28*3)), 60, 1, resultats[3] [10].value);
		write ( 0, (154+(28*4)), 60, 1, resultats[4] [10].value);
		
		//BRELAN///////////////////////
		If (resultats [1] [11].done == 1); write ( 0, (154+(28*1)), 82, 1, resultats[1] [11].value); End;
		If (resultats [2] [11].done == 1); write ( 0, (154+(28*2)), 82, 1, resultats[2] [11].value); End;
		If (resultats [3] [11].done == 1); write ( 0, (154+(28*3)), 82, 1, resultats[3] [11].value); End;
		If (resultats [4] [11].done == 1); write ( 0, (154+(28*4)), 82, 1, resultats[4] [11].value); End;
		
		//SUITES////////////////////////
		If (resultats [1] [12].done == 1); write ( 0, (154+(28*1)), 106, 1, resultats[1] [12].value); End;
		If (resultats [2] [12].done == 1); write ( 0, (154+(28*2)), 106, 1, resultats[2] [12].value); End;
		If (resultats [3] [12].done == 1); write ( 0, (154+(28*3)), 106, 1, resultats[3] [12].value); End;
		If (resultats [4] [12].done == 1); write ( 0, (154+(28*4)), 106, 1, resultats[4] [12].value); End;
		
		//FULL//////////////////////////
		If (resultats [1] [13].done == 1); write ( 0, (154+(28*1)), 128, 1, resultats[1] [13].value); End;
		If (resultats [2] [13].done == 1); write ( 0, (154+(28*2)), 128, 1, resultats[2] [13].value); End;
		If (resultats [3] [13].done == 1); write ( 0, (154+(28*3)), 128, 1, resultats[3] [13].value); End;
		If (resultats [4] [13].done == 1); write ( 0, (154+(28*4)), 128, 1, resultats[4] [13].value); End;
		
		//CARRE/////////////////////////
		If (resultats [1] [14].done == 1); write ( 0, (154+(28*1)), 152, 1, resultats[1] [14].value); End;
		If (resultats [2] [14].done == 1); write ( 0, (154+(28*2)), 152, 1, resultats[2] [14].value); End;
		If (resultats [3] [14].done == 1); write ( 0, (154+(28*3)), 152, 1, resultats[3] [14].value); End;
		If (resultats [4] [14].done == 1); write ( 0, (154+(28*4)), 152, 1, resultats[4] [14].value); End;
		
		//YAM///////////////////////////
		If (resultats [1] [15].done == 1); write ( 0, (154+(28*1)), 178, 1, resultats[1] [15].value); End;
		If (resultats [2] [15].done == 1); write ( 0, (154+(28*2)), 178, 1, resultats[2] [15].value); End;
		If (resultats [3] [15].done == 1); write ( 0, (154+(28*3)), 178, 1, resultats[3] [15].value); End;
		If (resultats [4] [15].done == 1); write ( 0, (154+(28*4)), 178, 1, resultats[4] [15].value); End;
		
		//T3////////////////////////////
		write ( 0, (154+(28*1)), 200, 1, resultats[1] [16].value);
		write ( 0, (154+(28*2)), 200, 1, resultats[2] [16].value);
		write ( 0, (154+(28*3)), 200, 1, resultats[3] [16].value);
		write ( 0, (154+(28*4)), 200, 1, resultats[4] [16].value);
		
		//TOTAL FINAL///////////////////
		write ( fnt4, (154+(28*1)), 225, 1, resultats[1] [17].value);
		write ( fnt4, (154+(28*2)), 225, 1, resultats[2] [17].value);
		write ( fnt4, (154+(28*3)), 225, 1, resultats[3] [17].value);
		write ( fnt4, (154+(28*4)), 225, 1, resultats[4] [17].value);
		

END



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Dcompte des ds - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PROCESS Occurence_tirage ()
//Compte du nombre d'occurence d'un chiffre

Private
cptr_occurence;
dice_value;

BEGIN
		
		dice_occurence [1].number = 0;
		dice_occurence [2].number = 0;
		dice_occurence [3].number = 0;
		dice_occurence [4].number = 0;
		dice_occurence [5].number = 0;
		dice_occurence [6].number = 0;
		
		From cptr_occurence = 0 to 4 step 1
			If (roll_dice[cptr_occurence].value == 1)
				dice_occurence [1].number = dice_occurence [1].number + 1;
			End;
		End;
		
		From cptr_occurence = 0 to 4 step 1
			If (roll_dice[cptr_occurence].value == 2)
				dice_occurence [2].number = dice_occurence [2].number + 1;
			End;
		End;
		
		From cptr_occurence = 0 to 4 step 1
			If (roll_dice[cptr_occurence].value == 3)
				dice_occurence [3].number = dice_occurence [3].number + 1;
			End;
		End;
		
		From cptr_occurence = 0 to 4 step 1
			If (roll_dice[cptr_occurence].value == 4)
				dice_occurence [4].number = dice_occurence [4].number + 1;
			End;
		End;
		
		From cptr_occurence = 0 to 4 step 1
			If (roll_dice[cptr_occurence].value == 5)
				dice_occurence [5].number = dice_occurence [5].number + 1;
			End;
		End;
		
		From cptr_occurence = 0 to 4 step 1
			If (roll_dice[cptr_occurence].value == 6)
				dice_occurence [6].number = dice_occurence [6].number + 1;
			End;
		End;
		
END



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//GameOver & resultat final - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PROCESS Game_over()

Private

BEGIN

		let_me_alone();
		Curseur();
				
		//SOUS TOTAL OK ////////////////////////////////
		resultats[1] [6].value = (resultats[1] [0].value + resultats[1] [1].value + resultats[1] [2].value + resultats[1] [3].value + resultats[1] [4].value + resultats[1] [5].value);
		resultats[2] [6].value = (resultats[2] [0].value + resultats[2] [1].value + resultats[2] [2].value + resultats[2] [3].value + resultats[2] [4].value + resultats[2] [5].value);
		resultats[3] [6].value = (resultats[3] [0].value + resultats[3] [1].value + resultats[3] [2].value + resultats[3] [3].value + resultats[3] [4].value + resultats[3] [5].value);
		resultats[4] [6].value = (resultats[4] [0].value + resultats[4] [1].value + resultats[4] [2].value + resultats[4] [3].value + resultats[4] [4].value + resultats[4] [5].value);
		
		
		//TOTAL1 OK ////////////////////////////////
		If (resultats[1] [6].value > 62)
			resultats[1] [7].value = (resultats[1] [6].value + 25);
		Else
			resultats[1] [7].value = resultats[1] [6].value;
		End;
		
		If (resultats[2] [6].value > 62)
			resultats[2] [7].value = (resultats[2] [6].value + 25);
		Else
			resultats[2] [7].value = resultats[2] [6].value;
		End;
		
		If (resultats[3] [6].value > 62)
			resultats[3] [7].value = (resultats[3] [6].value + 25);
		Else
			resultats[3] [7].value = resultats[3] [6].value;
		End;
		
		If (resultats[4] [6].value > 62)
			resultats[4] [7].value = (resultats[4] [6].value + 25);
		Else
			resultats[4] [7].value = resultats[4] [6].value;
		End;
		
		
		//TOTAL2 OK ////////////////////////////////
		resultats[1] [10].value = (resultats[1] [9].value - resultats[1] [8].value);
		resultats[2] [10].value = (resultats[2] [9].value - resultats[2] [8].value);
		resultats[3] [10].value = (resultats[3] [9].value - resultats[3] [8].value);
		resultats[4] [10].value = (resultats[4] [9].value - resultats[4] [8].value);
		
		
		//TOTAL3 OK ////////////////////////////////
		resultats[1] [16].value = (resultats[1] [11].value + resultats[1] [12].value + resultats[1] [13].value + resultats[1] [14].value + resultats[1] [15].value);
		resultats[2] [16].value = (resultats[2] [11].value + resultats[2] [12].value + resultats[2] [13].value + resultats[2] [14].value + resultats[2] [15].value);
		resultats[3] [16].value = (resultats[3] [11].value + resultats[3] [12].value + resultats[3] [13].value + resultats[3] [14].value + resultats[3] [15].value);
		resultats[4] [16].value = (resultats[4] [11].value + resultats[4] [12].value + resultats[4] [13].value + resultats[4] [14].value + resultats[4] [15].value);
		
		
		//TOTAL FINAL OK ////////////////////////////////
		resultats[1] [17].value = (resultats[1] [7].value + resultats[1] [10].value + resultats[1] [16].value);
		resultats[2] [17].value = (resultats[2] [7].value + resultats[2] [10].value + resultats[2] [16].value);
		resultats[3] [17].value = (resultats[3] [7].value + resultats[3] [10].value + resultats[3] [16].value);
		resultats[4] [17].value = (resultats[4] [7].value + resultats[4] [10].value + resultats[4] [16].value);
		
		
		
		
		//AFFICHAGE DES resultatS////////////////////////////////
		Fade_on();
		delete_text(all_text);
		PUT_SCREEN ( fpg1,16);
		write(fnt2,85,222,1,"GAME OVER");

		//1///////////////////////////
		write ( 0, (14+(28*1)), 35, 1, resultats[1] [0].value);
		write ( 0, (14+(28*2)), 35, 1, resultats[2] [0].value);
		write ( 0, (14+(28*3)), 35, 1, resultats[3] [0].value);
		write ( 0, (14+(28*4)), 35, 1, resultats[4] [0].value);
		
		//2///////////////////////////
		write ( 0, (14+(28*1)), 60, 1, resultats[1] [1].value);
		write ( 0, (14+(28*2)), 60, 1, resultats[2] [1].value);
		write ( 0, (14+(28*3)), 60, 1, resultats[3] [1].value);
		write ( 0, (14+(28*4)), 60, 1, resultats[4] [1].value);
		
		//3///////////////////////////
		write ( 0, (14+(28*1)), 82, 1, resultats[1] [2].value);
		write ( 0, (14+(28*2)), 82, 1, resultats[2] [2].value);
		write ( 0, (14+(28*3)), 82, 1, resultats[3] [2].value);
		write ( 0, (14+(28*4)), 82, 1, resultats[4] [2].value);
		
		//4///////////////////////////
		write ( 0, (14+(28*1)), 106, 1, resultats[1] [3].value);
		write ( 0, (14+(28*2)), 106, 1, resultats[2] [3].value);
		write ( 0, (14+(28*3)), 106, 1, resultats[3] [3].value);
		write ( 0, (14+(28*4)), 106, 1, resultats[4] [3].value);
		
		//5////////////////////////////
		write ( 0, (14+(28*1)), 128, 1, resultats[1] [4].value);
		write ( 0, (14+(28*2)), 128, 1, resultats[2] [4].value);
		write ( 0, (14+(28*3)), 128, 1, resultats[3] [4].value);
		write ( 0, (14+(28*4)), 128, 1, resultats[4] [4].value);
		
		//6////////////////////////////
		write ( 0, (14+(28*1)), 152, 1, resultats[1] [5].value);
		write ( 0, (14+(28*2)), 152, 1, resultats[2] [5].value);
		write ( 0, (14+(28*3)), 152, 1, resultats[3] [5].value);
		write ( 0, (14+(28*4)), 152, 1, resultats[4] [5].value);
		
		//SOUS-TOTAL///////////////////
		write ( 0, (14+(28*1)), 178, 1, resultats[1] [6].value);
		write ( 0, (14+(28*2)), 178, 1, resultats[2] [6].value);
		write ( 0, (14+(28*3)), 178, 1, resultats[3] [6].value);
		write ( 0, (14+(28*4)), 178, 1, resultats[4] [6].value);
		
		//T1///////////////////////////
		write ( 0, (14+(28*1)), 200, 1, resultats[1] [7].value);
		write ( 0, (14+(28*2)), 200, 1, resultats[2] [7].value);
		write ( 0, (14+(28*3)), 200, 1, resultats[3] [7].value);
		write ( 0, (14+(28*4)), 200, 1, resultats[4] [7].value);
		
		//MIN//////////////////////////
		write ( 0, (154+(28*1)), 10, 1, resultats[1] [8].value);
		write ( 0, (154+(28*2)), 10, 1, resultats[2] [8].value);
		write ( 0, (154+(28*3)), 10, 1, resultats[3] [8].value);
		write ( 0, (154+(28*4)), 10, 1, resultats[4] [8].value);
		
		//MAX//////////////////////////
		write ( 0, (154+(28*1)), 35, 1, resultats[1] [9].value);
		write ( 0, (154+(28*2)), 35, 1, resultats[2] [9].value);
		write ( 0, (154+(28*3)), 35, 1, resultats[3] [9].value);
		write ( 0, (154+(28*4)), 35, 1, resultats[4] [9].value);
		
		//T2///////////////////////////
		write ( 0, (154+(28*1)), 60, 1, resultats[1] [10].value);
		write ( 0, (154+(28*2)), 60, 1, resultats[2] [10].value);
		write ( 0, (154+(28*3)), 60, 1, resultats[3] [10].value);
		write ( 0, (154+(28*4)), 60, 1, resultats[4] [10].value);
		
		//BRELAN///////////////////////
		write ( 0, (154+(28*1)), 82, 1, resultats[1] [11].value);
		write ( 0, (154+(28*2)), 82, 1, resultats[2] [11].value);
		write ( 0, (154+(28*3)), 82, 1, resultats[3] [11].value);
		write ( 0, (154+(28*4)), 82, 1, resultats[4] [11].value);
		
		//SUITES////////////////////////
		write ( 0, (154+(28*1)), 106, 1, resultats[1] [12].value);
		write ( 0, (154+(28*2)), 106, 1, resultats[2] [12].value);
		write ( 0, (154+(28*3)), 106, 1, resultats[3] [12].value);
		write ( 0, (154+(28*4)), 106, 1, resultats[4] [12].value);
		
		//FULL//////////////////////////
		write ( 0, (154+(28*1)), 128, 1, resultats[1] [13].value);
		write ( 0, (154+(28*2)), 128, 1, resultats[2] [13].value);
		write ( 0, (154+(28*3)), 128, 1, resultats[3] [13].value);
		write ( 0, (154+(28*4)), 128, 1, resultats[4] [13].value);
		
		//CARRE/////////////////////////
		write ( 0, (154+(28*1)), 152, 1, resultats[1] [14].value);
		write ( 0, (154+(28*2)), 152, 1, resultats[2] [14].value);
		write ( 0, (154+(28*3)), 152, 1, resultats[3] [14].value);
		write ( 0, (154+(28*4)), 152, 1, resultats[4] [14].value);
		
		//YAM///////////////////////////
		write ( 0, (154+(28*1)), 178, 1, resultats[1] [15].value);
		write ( 0, (154+(28*2)), 178, 1, resultats[2] [15].value);
		write ( 0, (154+(28*3)), 178, 1, resultats[3] [15].value);
		write ( 0, (154+(28*4)), 178, 1, resultats[4] [15].value);
		
		//T3////////////////////////////
		write ( 0, (154+(28*1)), 205, 1, resultats[1] [16].value);
		write ( 0, (154+(28*2)), 205, 1, resultats[2] [16].value);
		write ( 0, (154+(28*3)), 205, 1, resultats[3] [16].value);
		write ( 0, (154+(28*4)), 205, 1, resultats[4] [16].value);
		
		//TOTAL FINAL///////////////////
		write ( fnt4, (154+(28*1)), 220, 1, resultats[1] [17].value);
		write ( fnt4, (154+(28*2)), 220, 1, resultats[2] [17].value);
		write ( fnt4, (154+(28*3)), 220, 1, resultats[3] [17].value);
		write ( fnt4, (154+(28*4)), 220, 1, resultats[4] [17].value);
		
		//TEST RETOUR MENU 16/09/2010
		Repeat
			Frame;
			If (key(__SELECT))	exit("",0);	End
		Until ((mouse.left AND mouse.x>=286 AND mouse.x<=315 AND mouse.y>=8 AND mouse.y<=32) OR key(__START))

				
		//RESTART GAME
		//============
		Fade_off();
		
		//Go back to menu
		delete_text(all_text);
		PUT_SCREEN ( fpg1,13); //Affiche l'arrire plan
		signal(type Table_resultats ,s_kill);
		signal(type Display_resultats,s_kill);
		signal(type Game,s_kill);
		Nettoyage_resultat ();
		Menu ();

		signal(type Game_over,s_kill);
		
		
		//FIN TEST RETOUR MENU 16/09/2010
		
END



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Go_back_menu - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PROCESS Go_back_menu();

BEGIN

		//RESTART GAME
		//============
		Fade_off();
		
		//Go back to menu
		delete_text(all_text);
		PUT_SCREEN ( fpg1,13); //Affiche l'arrire plan
		//signal(type Table_resultats ,s_kill);
		//signal(type Display_resultats,s_kill);
		//signal(type Game,s_kill);
		Nettoyage_resultat ();
		Menu ();
      
END



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Pointeur - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PROCESS Curseur();

BEGIN

		graph = 999;
		
		Loop
			x = mouse.x;
			y = mouse.y;
			z = -256;
			
			//Emulation de la souris avec le pad
			If (key(_down))	y += 10;	End;
			If (key(_up))	y -= 10;	End;
			If (key(_left))	x -= 10;	End;
			If (key(_right))	x += 10;	End;
			
			Frame;
		End;
      
END



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Nettoyage des crans - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PROCESS Nettoyage_ecran ()
//Clean the screen AND display the title

BEGIN

      delete_text(all_text);
      PUT_SCREEN ( fpg1,13); //Affiche l'arrire plan
      write ( 1, 160, 20, 1, "- YAHTZEE -"); //titre
      Frame(200);

END



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Nettoyage des rsultats - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PROCESS Nettoyage_resultat ()

Private
colonne;
ligne;

BEGIN

		From colonne = 0  to 4 step 1
			From ligne = 0  to 17 step 1
				resultats[colonne] [ligne].value = 0;
				resultats[colonne] [ligne].done = 0;				
			End;
		End;
		
END

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//test_next - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
FUNCTION test_next(int x_case, int y_case);

Private

BEGIN

		If (mouse.left)
			If (x_case >= 286 AND x_case <= 315)
				If (y_case >= 208 AND y_case <= 232)
							return 1;
						Else
							return 0;
						End;
				Else
						return 0;
				End;
		Else
				return 0;
		End;
						
END


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//test_roll - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
FUNCTION test_roll(int x_case, int y_case);

Private

BEGIN

		If (mouse.left)
				If (x_case >= 178 AND x_case <= 262)
						If (y_case >= 113 AND y_case <= 157)
							return 1;
						Else
							return 0;
						End;
				Else
						return 0;
				End;
		Else
				return 0;
		End;
						
END


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//test_dice - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
FUNCTION test_dice(int x_case, int y_case);

BEGIN

		If (y_case >= 185 AND y_case <= 215)
				If (x_case >= 25 AND x_case <= 55)
						return 0;
				Elsif (x_case >= 65 AND x_case <= 95)
						return 1;
				Elsif (x_case >= 105 AND x_case <= 135)
						return 2;
				Elsif (x_case >= 145 AND x_case <= 175)
						return 3;
				Elsif (x_case >= 185 AND x_case <= 215)
						return 4;
				Else
						return -1;
				End;
		End;
						
END

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Temporiser - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
FUNCTION patiente(int tps)

BEGIN

		timer[0]=0;
		// attente
		while (timer[0] <= tps ) 	frame;	end
		
END


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Roll_bouton - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PROCESS Display_roll_button(INT type_button);

BEGIN

		If (type_button == 0)
				graph = 15;
		Elsif (type_button == 1)
				graph = 21;
		End;
		x = 220;
		y = 95;
			
		Loop
			test_roll_button = COLLISION(type Curseur);
			Frame;
		End;
      
END


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Roll_bouton - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PROCESS Display_stop_button();

BEGIN

		graph = 14;
		x = 100;
		y = 95;
			
		Loop
			test_stop_button = COLLISION(type Curseur);
			Frame;
		End;
      
END



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//PAUSE - OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
PROCESS Pause();


Begin

	graph = 997;
	x = 160;
	y = 120;
	z = -256;
	
	Loop
		Frame;
	End;
	
End

